/* ========================================
 *  Slew - Slew.h
 *  Created 8/12/11 by SPIAdmin 
 *  Copyright (c) 2011 __MyCompanyName__, Airwindows uses the MIT license
 * ======================================== */

#ifndef __Slew_Slew_H
#define __Slew_Slew_H

#include "../../../configuration.h"
#ifdef SHR3D_SFX_CORE_AIRWINDOWS

#include "../common/airwin_consolidated_base.h"


// TODO: Change kFirstParameter to your first parameter and add any additional parameters.
namespace airwinconsolidated::Slew {
enum {
  kSlewParam = 0,
  kNumParameters = 1
};

// TODO: Add other macros or preprocessor defines here

// TODO: Change to reflect your plugin

class Slew final : public SfxCoreExtensionV1
{
public:
    Slew();
    ~Slew();
    
    // Configuration
    
                                                                  // when the plug-in is registered with them.
    
    
    // Processing
    void processBlock(float** inputs, float** outputs, int sampleFrames) override;
    int getParameterCount() const override;

    // Programs and parameters
   
    
    // parameter values are all 0.0f to 1.0f
    float getParameter(int index) override;
    void setParameter(int index, float value) override;

    void getParameterLabel(int index, char *text) override;
    void getParameterName(int index, char *text) override;
    void getParameterDisplay(int index, char *text) override;
    
    // Capabilities
private:
    
	float gain;
	double lastSampleL;
	double lastSampleR;
	uint32_t fpdL;
	uint32_t fpdR;
};

} // end namespace

#endif // SHR3D_SFX_CORE_AIRWINDOWS

#endif
